(*
  Object Pascal translation of the Altap Salamander SDK library.
  Original source: spl_gui.h

  Portions created by ALTAP are Copyright (c) ALTAP, spol. s r.o.
  All rights reserved.

  Portions created by LostGenius Posse are Copyright (c) 2007, LostGenius Posse (Timo 'jomanto' Boll)
  All rights reserved.

  Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

      * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
      * Redistributions in binary form may reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
      * Neither the name of the LostGenius Posse nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*)
(*
  History:

  2007-05-31: initial version
*)
unit spl_gui;

interface

uses
  winliblt;

const
  ////////////////////////////////////////////////////////
  //                                                    //
  // Prostor WM_APP + 200 az WM_APP + 399 je v const.h  //
  // vyjmut z prostoru pouzivaneho pro interni zpravy   //
  // Salamandera.                                       //
  //                                                    //
  ////////////////////////////////////////////////////////

  // menu messages
  WM_USER_ENTERMENULOOP   = WM_APP + 200;                                       // [0, 0] doslo ke vstupu do menu
  WM_USER_LEAVEMENULOOP   = WM_APP + 201;                                       // [0, 0] byl ukoncen rezim menu loop; tato message je sendnuta pred postnutim commandu
  WM_USER_LEAVEMENULOOP2  = WM_APP + 202;                                       // [0, 0] byl ukoncen rezim menu loop; tato message je postnuta az po commandu
  WM_USER_INITMENUPOPUP   = WM_APP + 204;                                       // [(CGUIMenuPopupAbstract*)menuPopup, LOWORD(uPos), HIWORD(uID)]
  WM_USER_UNINITMENUPOPUP = WM_APP + 205;                                       // [(CGUIMenuPopupAbstract*)menuPopup, LOWORD(uPos), HIWORD(uID)]
  WM_USER_CONTEXTMENU     = WM_APP + 206;                                       // [(CGUIMenuPopupAbstract*)menuPopup, (BOOL)fromMouse
                                                                                //   (pokud dojde mysi akci, je rovno TRUE (pouzit GetMessagePos);
                                                                                //    pokud jde o klavesnicovou akci VK_APPS nebo Shift+F10, je rovno FALSE)]
                                                                                // p.s. pokud vrati TRUE, dojde ke spusteni prikazu menu nebo otevreni submenu
                                                                                // Pokud chceme v Salamu pretypovat menuPopup na CMenuPopup,
                                                                                // pouzijeme (CMenuPopup*)(CGUIMenuPopupAbstract*)menuPopup.

  // toolbar messages
  WM_USER_TBDROPDOWN      = WM_APP + 220;                                       // [HWND hToolBar, int buttonIndex]
  WM_USER_TBENUMBUTTON    = WM_APP + 221;                                       // [HWND hToolBar, TLBI_ITEM_INFO *tii]
  WM_USER_TBRESET         = WM_APP + 222;                                       // [HWND hToolBar, TOOLBAR_TOOLTIP *tt]
  WM_USER_TBBEGINADJUST   = WM_APP + 223;                                       // [HWND hToolBar, 0]
  WM_USER_TBENDADJUST     = WM_APP + 224;                                       // [HWND hToolBar, 0]
  WM_USER_TBGETTOOLTIP    = WM_APP + 225;                                       // [HWND hToolBar, 0]
  WM_USER_TBCHANGED       = WM_APP + 226;                                       // [HWND hToolBar, 0]

  // tooltip messages
  TOOLTIP_TEXT_MAX        = 5000;                                               // maximalni delka retezce tool tipu (zprava WM_USER_TTGETTEXT)
  WM_USER_TTGETTEXT       = WM_APP + 240;                                       // [ID predany v SetCurrentToolTip, buffer omezeny TOOLTIP_TEXT_MAX]

  // button pressed
  WM_USER_BUTTON          = WM_APP + 244;                                       // [(LO)WORD buttonID, (LO)WORD udalost byla vyvolana z klavesnice, pokud otevirame menu, vybrat prvni polozku]
  // drop down of button pressed
  WM_USER_BUTTONDROPDOWN  = WM_APP + 245;                                       // [(LO)WORD buttonID, (LO)WORD udalost byla vyvolana z klavesnice, pokud otevirame menu, vybrat prvni polozku]

  WM_USER_KEYDOWN         = WM_APP + 246;                                       // [(LO)WORD ctrlID, DWORD virtual-key code]

//
// ****************************************************************************
// CGUIStaticTextAbstract
//

  STF_CACHED_PAINT    = $0000000001;                                            // zobrazeni textu pojede pres cache (nebude blikat)
                                                                                // POZOR: zobrazeni je radove pomalejsi nez bez tohoto flagu.
                                                                                // Nepouzivat v pripade textu v dialogu, ktere se zobrazi
                                                                                // jednou a pak zustavaji nemenne.
                                                                                // Pouzivat u casto/rychle se menicich textu (provadena operace).
  STF_BOLD            = $0000000002;                                            // pro text bude pouzit tucny font
  STF_UNDERLINE       = $0000000004;                                            // pro text bude pouzit font s podtrzenim (pro spatnou citelnost
                                                                                // pouzivat pouze pro HyperLink a specialni pripady)
  STF_DOTUNDERLINE    = $0000000008;                                            // text bude carkovane podtrzeny (pro spatnou citelnost
                                                                                // pouzivat pouze pro HyperLink a specialni pripady)
  STF_HYPERLINK_COLOR = $0000000010;                                            // barva textu bude urcena podle barvy hyperlinku
  STF_END_ELLIPSIS    = $0000000020;                                            // pokud bude text prilis dlouhy, bude ukoncen vypustkou "..."
  STF_PATH_ELLIPSIS   = $0000000040;                                            // pokud bude text prilis dlouhy, bude zkracen a bude do nej vlozena
                                                                                // vypustka "..." tak, aby byl konec viditelny
  STF_HANDLEPREFIX    = $0000000080;                                            // znaky za '&' budou podtrzene; nelze pouzit s STF_END_ELLIPSIS nebo s STF_PATH_ELLIPSIS

//
// ****************************************************************************
// CGUIMenuPopupAbstract
//

  MNTT_IT = 1;                                                                  // item
  MNTT_PB = 2;                                                                  // popup begin
  MNTT_PE = 3;                                                                  // popup end
  MNTT_SP = 4;                                                                  // separator

  MNTS_B  = $01;                                                                // skill level beginned
  MNTS_I  = $02;                                                                // skill level intermediate
  MNTS_A  = $04;                                                                // skill level advanced

//
// ****************************************************************************
// CGUIMenuPopupAbstract
//

  MENU_MASK_TYPE          = $00000001;                                          // Retrieves or sets the 'Type' member.
  MENU_MASK_STATE         = $00000002;                                          // Retrieves or sets the 'State' member.
  MENU_MASK_ID            = $00000004;                                          // Retrieves or sets the 'ID' member.
  MENU_MASK_SUBMENU       = $00000008;                                          // Retrieves or sets the 'SubMenu' member.
  MENU_MASK_CHECKMARKS    = $00000010;                                          // Retrieves or sets the 'HBmpChecked' and 'HBmpUnchecked' members.
  MENU_MASK_BITMAP        = $00000020;                                          // Retrieves or sets the 'HBmpItem' member.
  MENU_MASK_STRING        = $00000080;                                          // Retrieves or sets the 'String' member.
  MENU_MASK_IMAGEINDEX    = $00000100;                                          // Retrieves or sets the 'ImageIndex' member.
  MENU_MASK_ICON          = $00000200;                                          // Retrieves or sets the 'HIcon' member.
  MENU_MASK_OVERLAY       = $00000400;                                          // Retrieves or sets the 'HOverlay' member.
  MENU_MASK_CUSTOMDATA    = $00000800;                                          // Retrieves or sets the 'CustomData' member.
  MENU_MASK_ENABLER       = $00001000;                                          // Retrieves or sets the 'Enabler' member.
  MENU_MASK_SKILLLEVEL    = $00002000;                                          // Retrieves or sets the 'SkillLevel' member.
  MENU_MASK_FLAGS         = $00004000;                                          // Retrieves or sets the 'Flags' member.

  MENU_TYPE_STRING        = $00000001;                                          // Displays the menu item using a text string.
  MENU_TYPE_BITMAP        = $00000002;                                          // Displays the menu item using a bitmap.
  MENU_TYPE_SEPARATOR     = $00000004;                                          // Specifies that the menu item is a separator.
  MENU_TYPE_OWNERDRAW     = $00000100;                                          // Assigns responsibility for drawing the menu item to the window that owns the menu.
  MENU_TYPE_RADIOCHECK    = $00000200;                                          // Displays selected menu items using a radio-button mark instead of a check mark if the HBmpChecked member is NULL.

  MENU_FLAG_NOHOTKEY      = $00000001;                                          // AssignHotKeys will skip this item

  MENU_STATE_GRAYED       = $00000001;                                          // Disables the menu item and grays it so that it cannot be selected.
  MENU_STATE_CHECKED      = $00000002;                                          // Checks the menu item.
  MENU_STATE_DEFAULT      = $00000004;                                          // Specifies that the menu item is the default. A menu can contain only one default menu item, which is displayed in bold.

  MENU_LEVEL_BEGINNER     = $00000001;
  MENU_LEVEL_INTERMEDIATE = $00000002;
  MENU_LEVEL_ADVANCED     = $00000004;

  MENU_POPUP_THREECOLUMNS = $00000001;
  MENU_POPUP_UPDATESTATES = $00000002;                                          // pred otevrenim se zavola UpdateStates

  // tyto flagy jsou v prubehu vetve modifikovany pro jednolive popupy
  MENU_TRACK_SELECT       = $00000001;                                          // If this flag is set, the function select item specified by SetSelectedItemIndex.
  //MENU_TRACK_LEFTALIGN    = $00000000;                                          // If this flag is set, the function positions the shortcut menu so that its left side is aligned with the coordinate specified by the x parameter.
  //MENU_TRACK_TOPALIGN     = $00000000;                                          // If this flag is set, the function positions the shortcut menu so that its top side is aligned with the coordinate specified by the y parameter.
  //MENU_TRACK_HORIZONTAL   = $00000000;                                          // If the menu cannot be shown at the specified location without overlapping the excluded rectangle, the system tries to accommodate the requested horizontal alignment before the requested vertical alignment.
  MENU_TRACK_CENTERALIGN  = $00000002;                                          // If this flag is set, the function centers the shortcut menu horizontally relative to the coordinate specified by the x parameter.
  MENU_TRACK_RIGHTALIGN   = $00000004;                                          // Positions the shortcut menu so that its right side is aligned with the coordinate specified by the x parameter.
  MENU_TRACK_VCENTERALIGN = $00000008;                                          // If this flag is set, the function centers the shortcut menu vertically relative to the coordinate specified by the y parameter.
  MENU_TRACK_BOTTOMALIGN  = $00000010;                                          // If this flag is set, the function positions the shortcut menu so that its bottom side is aligned with the coordinate specified by the y parameter.
  MENU_TRACK_VERTICAL     = $00000100;                                          // If the menu cannot be shown at the specified location without overlapping the excluded rectangle, the system tries to accommodate the requested vertical alignment before the requested horizontal alignment.
  // spolecne flagy pro jednu vetev Track
  MENU_TRACK_NONOTIFY     = $00001000;                                          // If this flag is set, the function does not send notification messages when the user clicks on a menu item.
  MENU_TRACK_RETURNCMD    = $00002000;                                          // If this flag is set, the function returns the menu item identifier of the user's selection in the return value.
  //MENU_TRACK_LEFTBUTTON   = $00000000;                                          // If this flag is set, the user can select menu items with only the left mouse button.
  MENU_TRACK_RIGHTBUTTON  = $00010000;                                          // If this flag is set, the user can select menu items with both the left and right mouse buttons.

//
// ****************************************************************************
// CGUIToolBarAbstract
//

  // Toolbar Styles

  TLB_STYLE_IMAGE          = $00000001;                                         // budou zobrazovany ikonky s ImageIndex != -1
                                                                                // zaroven GetNeededSpace bude pocitat s vyskou ikonek
  TLB_STYLE_TEXT           = $00000002;                                         // budou zobrazovany u polozek s nastavenym TLBI_STYLE_SHOWTEXT
                                                                                // zaroven GetNeededSpace bude pocitat s velikosti fontu
  TLB_STYLE_ADJUSTABLE     = $00000004;                                         // lze toolbar konfigurovat?
  TLB_STYLE_VERTICAL       = $00000008;                                         // tlacitka jsou pod sebou, separatory vodorovne, vylucuje se s TLB_STYLE_TEXT,
                                                                                // protoze svisle texty nejsou podporovany

  // Toolbar Item Masks
  TLBI_MASK_ID             = $00000001;                                         // Retrieves or sets the 'ID' member.
  TLBI_MASK_CUSTOMDATA     = $00000002;                                         // Retrieves or sets the 'CustomData' member.
  TLBI_MASK_IMAGEINDEX     = $00000004;                                         // Retrieves or sets the 'ImageIndex' member.
  TLBI_MASK_ICON           = $00000008;                                         // Retrieves or sets the 'HIcon' member.
  TLBI_MASK_STATE          = $00000010;                                         // Retrieves or sets the 'State' member.
  TLBI_MASK_TEXT           = $00000020;                                         // Retrieves or sets the 'Text' member.
  TLBI_MASK_TEXTLEN        = $00000040;                                         // Retrieves the 'TextLen' member.
  TLBI_MASK_STYLE          = $00000080;                                         // Retrieves or sets the 'Style' member.
  TLBI_MASK_WIDTH          = $00000100;                                         // Retrieves or sets the 'Width' member.
  TLBI_MASK_ENABLER        = $00000200;                                         // Retrieves or sets the 'Enabler' member.

  // Toolbar Item Styles
  TLBI_STYLE_CHECK            = $00000001;                                      // Creates a dual-state push button that toggles between
                                                                                // the pressed and nonpressed states each time the user
                                                                                // clicks it. The button has a different background color
                                                                                // when it is in the pressed state.

  TLBI_STYLE_RADIO            = $00000002;                                      // Pokud neni pri kliknuti TLBI_STATE_CHECKED, prepne se
                                                                                // do tohoto stavu. Pokud uz tam je, zustane tam.

  TLBI_STYLE_DROPDOWN         = $00000004;                                      // Creates a drop-down style button that can display a
                                                                                // list when the button is clicked. Instead of the
                                                                                // WM_COMMAND message used for normal buttons,
                                                                                // drop-down buttons send a WM_USER_TBDROPDOWN notification.
                                                                                // An application can then have the notification handler
                                                                                // display a list of options.

  TLBI_STYLE_NOPREFIX         = $00000008;                                      // Specifies that the button text will not have an
                                                                                // accelerator prefix associated with it.

  TLBI_STYLE_SEPARATOR        = $00000010;                                      // Creates a separator, providing a small gap between
                                                                                // button groups. A button that has this style does not
                                                                                // receive user input.

  TLBI_STYLE_SHOWTEXT         = $00000020;                                      // Specifies that button text should be displayed.
                                                                                // All buttons can have text, but only those buttons
                                                                                // with the BTNS_SHOWTEXT button style will display it.
                                                                                // This style must be used with the TLB_STYLE_TEXT style.

  TLBI_STYLE_WHOLEDROPDOWN    = $00000040;                                      // Specifies that the button will have a drop-down arrow,
                                                                                // but not as a separate section.

  TLBI_STYLE_SEPARATEDROPDOWN = $00000080;                                      // Specifies that the button will have a drop-down arrow,
                                                                                // in separated section.

  TLBI_STYLE_FIXEDWIDTH       = $00000100;                                      // Sirka teto polozky neni automaticky pocitana.


  // Toolbar Item States
  TLBI_STATE_CHECKED          = $00000001;                                      // The button has the TLBI_STYLE_CHECK style and is being clicked.
  TLBI_STATE_GRAYED           = $00000002;                                      // The button is grayed and cannot receive user input.
  TLBI_STATE_PRESSED          = $00000004;                                      // The button is being clicked.
  TLBI_STATE_DROPDOWNPRESSED  = $00000008;                                      // The drop down is being clicked.

//
// ****************************************************************************
// CSalamanderGUIAbstract
//

  BTF_CHECKBOX      = $00000001;                                                // tlacitko se chova jako checkbox
  BTF_DROPDOWN      = $00000002;                                                // tlacitko vzadu obsahuje drop down cast, posila WM_USER_BUTTONDROPDOWN message do parenta
  BTF_LBUTTONDOWN   = $00000004;                                                // tlacitko reaguje na LBUTTONDOWN a posila WM_USER_BUTTON
  BTF_RIGHTARROW    = $00000008;                                                // tlacitko ma na konci sipku ukazujici vpravo
  BTF_MORE          = $00000010;                                                // tlacitko ma na konci symbol pro rozbaleni dialogu

type
//
// ****************************************************************************
// CGUIProgressBarAbstract
//

  TGUIProgressBarAbstract = class
    // nastavuje progres, pripadne text uprostred
    //
    // progres dokaze pracovat ve dvou rezimech:
    //   1) pro 'progress' >= 0 jde o klasicky teplomer 0% az 100%
    //      v tomto rezimu lze pomoci promenne 'text' nastavit vlastni text zobrazeny uprostred
    //      pokud je 'text' == NULL, zobrazi se uprostred standardni procenta
    //   2) pro 'progress' == -1 jde o neurcity stav, kdy maly obdelnicek jezdi tam a zpet
    //      pohyb se ridi pomoci metod SetSelfMoveTime(), SetSelfMoveSpeed() a Stop()
    //
    // prekresleni se provadi okamzite; u vetsiny operaci je vhodne data ukladat v parent
    // dialogu do cache a spustit si 100ms timer, na ktery teprve volat tuto metodu
    //
    // mozne volat z libovolneho threadu, thread s controlem musi bezet, jinak dojde k zablokovani
    // (pro doruceni hodnoty 'progress' controlu se pouziva SendMessage);
    procedure SetProgress( progress : DWORD; text : PChar ); virtual; stdcall; abstract;

    // ma vyznam v kombinaci s volanim SetProgress(-1)
    // urcuje kolik milisekund po zavolani SetProgress(-1) se jeste bude obdelnicek sam pohybovat
    // pokud v tuto dobu dojde k zavolani dalsiho SetProgress(-1), cas se pocita zase od zacatku
    // pokud je 'time'==0, posune se obdelnicek pouze jednou prave pri zavolani SetProgress(-1)
    // pro hodnotu 'time'==0xFFFFFFFF se bude obdelnicek posouvat do nekonecna (implicitni hodnota)
    procedure SetSelfMoveTime( time : DWORD ); virtual; stdcall; abstract;

    // ma vyznam v kombinaci s volanim SetProgress(-1)
    // urcuje cas mezi posunutim obdelnicku v milisekundach
    // implicitni hodnota je 'moveTime'==50, coz znamena 20 pohybu za vterinu
    procedure SetSelfMoveSpeed( moveTime : DWORD ); virtual; stdcall; abstract;

    // ma vyznam v kombinaci s volanim SetProgress(-1)
    // pokud se obdelnicek prave pohybuje (diky SetSelfMoveTime), bude zastaven
    procedure Stop; virtual; stdcall; abstract;

  // priklady pouziti:
  //
  // 1. obdelnicek chceme posouvat rucne, bez naseho prispeni se nepohybuje
  //
  //   SetSelfMoveTime(0)           // zakazeme samovolny pohyb
  //   SetProgress(-1, NULL)        // posuneme o jeden dilek
  //   ...
  //   SetProgress(-1, NULL)        // posuneme o jeden dilek
  //
  // 2. obdelnicek se ma pohybovat samostatne a do az do zavolani Stop
  //
  //   SetSelfMoveTime(0xFFFFFFFF)  // nekonecny pohyb
  //   SetSelfMoveSpeed(50)         // 20 pohybu za vterinu
  //   SetProgress(-1, NULL)        // nastartujeme obdelnicek
  //   ...                          // neco kutime
  //   Stop()                       // zastavime obdelnicek
  //
  // 3. obdelnicek se ma pohybovat omezenou dobu, po ktere se zastavi
  //   pokud do nej behem teto doby "drcneme", doba se obnovi
  //
  //   SetSelfMoveTime(1000)        // samovolne se pohybuje vterinu, pak se zastavi
  //   SetSelfMoveSpeed(50)         // 20 pohybu za vterinu
  //   SetProgress(-1, NULL)        // nastartujeme obdelnicek na dobu jedne vteriny
  //   ...
  //   SetProgress(-1, NULL)        // ozivime obdelnicek na dalsi vterinu
  //
  // 4. behem operace doslo k pausnuti a chceme to vizualizovat v progress bar
  //
  //   SetProgress(0, NULL)         // 0%
  //   SetProgress(100, NULL)       // 10%
  //   SetProgress(200, NULL)       // 20%
  //   SetProgress(300, "(paused)") // 30% -- misto "30 %" se zobrazi text "(paused)"
  //   ... (cekame na resume)
  //   SetProgress(300, NULL)       // 30% (text paused) zase vypneme a jedeme dal
  //   SetProgress(400, NULL)       // 40%
  //   ...

  end;

//
// ****************************************************************************
// CGUIStaticTextAbstract
//

  TGUIStaticTextAbstract = class
  // Vsechny metody je mozne volat pouze z threadu parent okna, ve kterem
  // byl objekt pripojen na windows control a ziskan ukazatel na toto rozhrani.
  //
  // Control lze v dialogu navstivit z klavesnice, pokud mu priradime styl WS_TABSTOP.

    // nastavi text controlu; volani teto metody je rychlejsi a mene vypocetne narocne
    // nez nastavovani textu pomoci WM_SETTEXT; vraci TRUE v pripade uspechu, jinak FALSE
    function SetText( text : PChar ) : BOOL; virtual; stdcall; abstract;

    // vrati text controlu; mozne volat z libovolneho threadu;
    // vrati NULL, pokud jeste nebylo volano SetText a static control byl bez textu
    function GetText : PChar; virtual; stdcall; abstract;

    // nastavi znak pro oddeleni casti cesty; ma vyznam v pripade STF_PATH_ELLIPSIS;
    // implicitne je nastaveno na '\\';
    procedure SetPathSeparator( separator : Char ); virtual; stdcall; abstract;

    // priradi text, ktery bude zobrazen jako tooltip
    // vraci TRUE, pokud se podarilo naalokovat kopii textu, jinak vraci FALSE
    function SetToolTipText( text : PChar ) : BOOL; virtual; stdcall; abstract;

    // priradi okno a id, kteremu se pri zobrazeni tooltipu zasle WM_USER_TTGETTEXT
    procedure SetToolTip( hNotifyWindow : HWND; id : DWORD ); virtual; stdcall; abstract;
  end;

//
// ****************************************************************************
// CGUIHyperLinkAbstract
//

  TGUIHyperLinkAbstract = class
  // Vsechny metody je mozne volat pouze z threadu parent okna, ve kterem
  // byl objekt pripojen na windows control a ziskan ukazatel na toto rozhrani.
  //
  // Control lze v dialogu navstivit z klavesnice, pokud mu priradime styl WS_TABSTOP.

    // nastavi text controlu; volani teto metody je rychlejsi a mene vypocetne narocne
    // nez nastavovani textu pomoci WM_SETTEXT; vraci TRUE v pripade uspechu, jinak FALSE
    function SetText( text : PChar ) : BOOL; virtual; stdcall; abstract;

    // vrati text controlu; mozne volat z libovolneho threadu
    // vrati NULL, pokud jeste nebylo volano SetText a static control byl bez textu
    function GetText : PChar; virtual; stdcall; abstract;

    // priradi akci otevreni URL adresy (file="http://www.altap.cz") nebo
    // spusteni programu (file="C:\\TEST.EXE"); na parametr je volano
    // ShellExecute s 'open' commandem.
    procedure SetActionOpen( _file : PChar ); virtual; stdcall; abstract;

    // priradi akci PostCommand(WM_COMMAND, command, 0) do parent okna
    procedure SetActionPostCommand( command : Word ); virtual; stdcall; abstract;

    // priradi akci zobrazeni hintu a tooltipu 'text'
    // pokud je text NULL, je mozne tooltip priradit volanim metody
    // SetToolTipText nebo SetToolTip; metoda pak vraci vzdy TRUE
    // pokud je text ruzny od NULL, vraci metoda TRUE, pokud se podarilo
    // naalokovat kopii textu, jinak vraci FALSE
    // tooltip je mozne zobrazit kavesou Space/Up/Down (pokud je focus
    // na controlu) a kliknutim mysi; hint (tooltip) je pak zobrazen primo
    // pod textem a nezavre se dokud uzivatel neklikne mimo nej mysi nebo
    // nestiskne nejakou klavesu
    function SetActionShowHint( text : PChar ) : BOOL; virtual; stdcall; abstract;

    // priradi text, ktery bude zobrazen jako tooltip
    // vraci TRUE, pokud se podarilo naalokovat kopii textu, jinak vraci FALSE
    function SetToolTipText( text : PChar ) : BOOL; virtual; stdcall; abstract;

    // priradi okno a id, kteremu se pri zobrazeni tooltipu zasle WM_USER_TTGETTEXT
    procedure SetToolTip( hNotifyWindow : HWND; id : DWORD ); virtual; stdcall; abstract;
  end;


//
// ****************************************************************************
// CGUIButtonAbstract
//


  TGUIButtonAbstract = class
  // Vsechny metody je mozne volat pouze z threadu parent okna, ve kterem
  // byl objekt pripojen na windows control a ziskan ukazatel na toto rozhrani.

    // priradi text, ktery bude zobrazen jako tooltip; vraci TRUE v pripade uspechu, jinak FALSE
    function SetToolTipText( text : PChar ) : BOOL; virtual; stdcall; abstract;

    // priradi okno a id, kteremu se pri zobrazeni tooltipu zasle WM_USER_TTGETTEXT
    procedure SetToolTip( hNotifyWindow : HWND; id : DWORD ); virtual; stdcall; abstract;
  end;

//
// ****************************************************************************
// CGUIColorArrowButtonAbstract
//

  TGUIColorArrowButtonAbstract = class
  // Vsechny metody je mozne volat pouze z threadu parent okna, ve kterem
  // byl objekt pripojen na windows control a ziskan ukazatel na toto rozhrani.

    // nastavi barvu textu 'textColor' a barvu pozadi 'bkgndColor'
    procedure SetColor( textColor : TColorRef; bkgndColor : TColorRef ); virtual; stdcall; abstract;

    // nastavi barvu textu 'textColor'
    procedure SetTextColor( textColor : TColorRef ); virtual; stdcall; abstract;

    // nastavi barvu pozadi 'bkgndColor'
    procedure SetBkgndColor( bkgndColor : TColorRef ); virtual; stdcall; abstract;

    // vrati barvu textu
    function GetTextColor : TColorRef; virtual; stdcall; abstract;

    // vrati barvu pozadi
    function GetBkgndColor : TColorRef; virtual; stdcall; abstract;
  end;


//
// ****************************************************************************
// CGUIMenuPopupAbstract
//

  TGUIMenuPopupAbstract = class;

  MENU_TEMPLATE_ITEM = packed record
    RowType    : Integer;                                                       // MNTT_*
    TextResID  : Integer;                                                       // resource textu
    SkillLevel : Byte;                                                          // MNTS_*
    ID         : DWORD;                                                         // genrovany command
    ImageIndex : Shortint;                                                      // -1 = zadna ikonka
    State      : DWORD;
    Enabler    : PDWORD;                                                        // ridici promenna pro enablovani polozky
  end;
  PMENU_TEMPLATE_ITEM = ^MENU_TEMPLATE_ITEM;

  MENU_ITEM_INFO = packed record
    Mask          : DWORD;
    Type_         : DWORD;
    State         : DWORD;
    ID            : DWORD;
    SubMenu       : TGUIMenuPopupAbstract;
    HBmpChecked   : HBITMAP;
    HBmpUnchecked : HBITMAP;
    HBmpItem      : HBITMAP;
    String_       : PChar;
    StringLen     : DWORD;
    ImageIndex    : Integer;
    HIcon         : HICON;
    HOverlay      : HICON;
    CustomData    : DWORD;
    SkillLevel    : DWORD;
    Enabler       : PDWORD;
    Flags         : DWORD;
  end;
  PMENU_ITEM_INFO = ^MENU_ITEM_INFO;
(*
Mask
  Members to retrieve or set. This member can be one or more of these values.

Type
  Typ polozky. Tato promenna muze nabivat jednu nebo vice hodnot:

   MENU_TYPE_OWNERDRAW    Vykresleni polozek zajisti okno vlasntici menu.
                          Pro kazdou polozku menu je zaslan dotaz WM_MEASUREITEM a
                          WM_DRAWITEM. Promenna TypeData obsahuje 32-buitovou
                          hodnotu definovanou aplikaci.

   MENU_TYPE_RADIOCHECK   Checked polozky jsou zobrazovany s teckou misto s fajfkou,
                          je-li HBmpChecked rovno NULL.

   MENU_TYPE_SEPARATOR    Horiznotalni oddelovaci cara. TypeData nema vyznam.

   MENU_TYPE_STRING       Polozka obsahuje textovy retezec. TypeData ukazuje na nulou
                          zakonceny retzec.

   MENU_TYPE_BITMAP       Polozka obsahuje bitmapu.

  Hodnoty MENU_TYPE_BITMAP, MENU_TYPE_SEPARATOR a MENU_TYPE_STRING nemohou byt pouzity spolecne.

State
  Stav polozky. Tato promenna muze nabivat jednu nebo vice hodnot:

   MENU_STATE_CHECKED     Polozka je checked.

   MENU_STATE_DEFAULT     Menu muze obsahovat pouze jednu default polozku. Je
                          vykreslna tucne.

   MENU_STATE_GRAYED      Zakaze polozku - bude sediva a nepujde vybrat.

SkillLevel
  Uzivatelska uroven polozky. Tato promena muze nabyvat jedne z hodnot:

   MENU_LEVEL_BEGINNER       zacatecnik - bude se zobrazovat vzdy
   MENU_LEVEL_INTERMEDIATE   stredni - bude se zobrazovat guru a strednim uzivatelum
   MENU_LEVEL_ADVANCED       pokrocily - bude se zobrazovat pouze guru uzivatelum

ID
  Aplikaci definovana 16-bitova hodnota, ktera identifikuje polozku menu.

SubMenu
  Ukazatel na popup menu pripojeneho na tutu polozku. Pokud tato polozka
  neotevira submenu, je SubMenu rovno NULL.

HBmpChecked
  Handle bitmapy, ktera je zobrazena pred polozkou v pripade, ze je polozka
  checked. Je-li tato promenna rovna NULL, pouzije
  se implicitni bitmapa. Jel-li nastaven bit MENU_TYPE_RADIOCHECK, je implicitni
  bitmapa tecka, jinak zatrznitko. Je-li ImageIndex ruzne od -1, nebude
  se tato bitmapa pouzivat.

HBmpUnchecked
  Handle bitmapy, ktera je zobrazena pred polozkou v pripade, ze neni polozka
  checked. Jeli tato promenna rovna NULL, nebude
  zobrazena zadna bitmapa. Je-li ImageIndex ruzne od -1, nebude
  se tato bitmapa pouzivat.

ImageIndex
  Index bitmapy v ImageListu CMenuPopup::HImageList. Bitmapa je vykreslena
  pred polozkou. V zavislosti na MENU_STATE_CHECKED a MENU_STATE_GRAYED.
  Je-li promenna rovna -1, nebude se vykreslovat.

Enabler
  Ukazatel na DWORD, ktery urcuje stav polozky: TRUE->enabled, FALSE->grayed.
  Pokud je NULL, polozka bude enabled.
*)

  TGUIMenuPopupAbstract = class
  // Vsechny metody je mozne volat pouze z threadu parent okna, ve kterem
  // byl objekt pripojen na windows control a ziskan ukazatel na toto rozhrani.

    //
    // LoadFromTemplate
    //   Builds menu contents based on 'menuTemplate',
    //
    // Parameters
    //   'hInstance'
    //      [in] Handle to the module containing the string resources (MENU_TEMPLATE_ITEM::TextResID).
    //
    //   'menuTemplate'
    //      [in] Pointer to a menu template.
    //
    //      A menu template consists of two or more MENU_TEMPLATE_ITEM structures.
    //      'MENU_TEMPLATE_ITEM::RowType' of first structure must be MNTT_PB (popup begin).
    //      'MENU_TEMPLATE_ITEM::RowType' of last structure must be MNTT_PE (popup end).
    //
    //   'enablersOffset'
    //      [in] Pointer to array of enablers.
    //
    //      If this parameter is NULL, 'MENU_ITEM_INFO::Enabler' value is pointer to enabler
    //      variable. Otherwise 'MENU_ITEM_INFO::Enabler' is index to the enablers array.
    //      Zero index is reserved for "always enabled" item.
    //
    //   'hImageList'
    //      [in] Handle of image list that the menu will use to display menu items images
    //      that are in their default state.
    //
    //      If this parameter is NULL, no images will be displayed in the menu items.
    //
    //   'hHotImageList'
    //      [in] Handle of image list that the menu will use to display menu items images
    //      that are in their selected or checked state.
    //
    //      If this parameter is NULL, normal images will be displayed instead of hot images.
    //
    //
    // Return Values
    //   Returns TRUE if successful, or FALSE otherwise.
    //
    function LoadFromTemplate( hInstance : HINST; menuTemplate : PMENU_TEMPLATE_ITEM;
                               enablersOffset : PDWORD; hImageList : HIMAGELIST;
                               hHotImageList : HIMAGELIST ) : BOOL; virtual; stdcall; abstract;

    //
    // SetSelectedItemIndex
    //   Sets the item which will be selected when menu popup is displayed.
    //
    // Parameters
    //   'index'
    //      [in] The index to select.
    //      If this value is -1, none of the items will be selected.
    //      This index is only applied when method Track with MENU_TRACK_SELECT flag is called.
    //
    // See Also
    //   GetSelectedItemIndex
    //
    procedure SetSelectedItemIndex( index : Integer ); virtual; stdcall; abstract;

    //
    // GetSelectedItemIndex
    //   Retrieves the currently selected item in the menu.
    //
    // Return Values
    //   Returns the index of the selected item, or -1 if no item is selected.
    //
    // See Also
    //   SetSelectedItemIndex
    //
    function GetSelectedItemIndex : Integer; virtual; stdcall; abstract;

    //
    // SetTemplateMenu
    //   Assigns the Windows menu handle which will be used as template when menu popup is displayed.
    //
    // Parameters
    //   'hWindowsMenu'
    //      [in] Handle to the Windows menu handle to be used as template.
    //      If this value is NULL, Windows menu handle will not be used.
    //
    // See Also
    //   GetTemplateMenu
    //
    procedure SetTemplateMenu( hWindowsMenu : HMENU ); virtual; stdcall; abstract;

    //
    // GetTemplateMenu
    //   Retrieves a handle to the Windows menu assigned as template.
    //
    // Return Values
    //   The return value is a handle to the Windows menu.
    //   If the object has no Windows menu template assigned, the return value is NULL.
    //
    // See Also
    //   SetTemplateMenu
    //
    function GetTemplateMenu : HMENU; virtual; stdcall; abstract;

    //
    // GetSubMenu
    //   Retrieves a pointer to the submenu activated by the specified menu item. 
    //
    // Parameters
    //   'position'
    //      [in] Specifies the zero-based position of the menu item that activates the submenu.
    //      The meaning of this parameter depends on the value of 'byPosition'.
    //
    //   'byPosition'
    //      [in] Value specifying the meaning of 'position'. If this parameter is FALSE, 'position'
    //      is a menu item identifier. Otherwise, it is a zero-based menu item position.
    //
    // Return Values
    //   If the function succeeds, the return value is a pointer to the submenu activated by the menu item.
    //   If the menu item does not activate submenu, the return value is NULL. 
    //

    function GetSubMenu( position : DWORD; byPosition : BOOL ) : TGUIMenuPopupAbstract; virtual; stdcall; abstract;

    //
    // InsertItem
    //   Inserts a new menu item at the specified position in a menu.
    //
    // Parameters
    //   'position'
    //      [in] Identifier or position of the menu item before which to insert the new item.
    //      The meaning of this parameter depends on the value of 'byPosition'.
    //
    //   'byPosition'
    //      [in] Value specifying the meaning of 'position'. If this parameter is FALSE, 'position'
    //      is a menu item identifier. Otherwise, it is a zero-based menu item position.
    //
    //   'mii'
    //      [in] Pointer to a MENU_ITEM_INFO structure that contains information about the new menu item.
    //
    // Return Values
    //   Returns TRUE if successful, or FALSE otherwise.
    //
    // See Also
    //   SetItemInfo, GetItemInfo
    //
    function InsertItem( position : DWORD; byPosition : BOOL; mii : PMENU_ITEM_INFO ) : BOOL; virtual; stdcall; abstract;

    //
    // SetItemInfo
    //   Changes information about a menu item.
    //
    // Parameters
    //   'position'
    //      [in] Identifier or position of the menu item to change.
    //      The meaning of this parameter depends on the value of 'byPosition'.
    //
    //   'byPosition'
    //      [in] Value specifying the meaning of 'position'. If this parameter is FALSE, 'position'
    //      is a menu item identifier. Otherwise, it is a zero-based menu item position.
    //
    //   'mii'
    //      [in] Pointer to a MENU_ITEM_INFO structure that contains information about the menu item
    //      and specifies which menu item attributes to change.
    //
    // Return Values
    //   Returns TRUE if successful, or FALSE otherwise.
    //
    // See Also
    //   InsertItem, GetItemInfo
    //
    function SetItemInfo( position : DWORD; byPosition : BOOL; mii : PMENU_ITEM_INFO ) : BOOL; virtual; stdcall; abstract;

    //
    // GetItemInfo
    //   Retrieves information about a menu item.
    //
    // Parameters
    //   'position'
    //      [in] Identifier or position of the menu item to get information about.
    //      The meaning of this parameter depends on the value of 'byPosition'.
    //
    //   'byPosition'
    //      [in] Value specifying the meaning of 'position'. If this parameter is FALSE, 'position'
    //      is a menu item identifier. Otherwise, it is a zero-based menu item position.
    //
    //   'mii'
    //      [in/out] Pointer to a MENU_ITEM_INFO structure that contains information to retrieve
    //      and receives information about the menu item.
    //
    // Return Values
    //   Returns TRUE if successful, or FALSE otherwise.
    //
    // See Also
    //   InsertItem, SetItemInfo
    //
    function GetItemInfo( position : DWORD; byPosition : BOOL; mii : PMENU_ITEM_INFO ) : BOOL; virtual; stdcall; abstract;

    //
    // SetStyle
    //   Sets the menu popup style.
    //
    // Parameters
    //   'style'
    //      [in] New menu style.
    //      This parameter can be a combination of menu popup styles MENU_POPUP_*.
    //
    // Return Values
    //   Returns TRUE if successful, or FALSE otherwise.
    //
    function SetStyle( style : DWORD ) : BOOL; virtual; stdcall; abstract;

    //
    // CheckItem
    //   Sets the state of the specified menu item's check-mark attribute to either checked or clear.
    //
    // Parameters
    //   'position'
    //      [in] Identifier or position of the menu item to change.
    //      The meaning of this parameter depends on the value of 'byPosition'.
    //
    //   'byPosition'
    //      [in] Value specifying the meaning of 'position'. If this parameter is FALSE, 'position'
    //      is a menu item identifier. Otherwise, it is a zero-based menu item position.
    //
    //   'checked'
    //      [in] Indicates whether the menu item will be checked or cleared.
    //      If this parameter is TRUE, sets the check-mark attribute to the selected state.
    //      If this parameter is FALSE, sets the check-mark attribute to the clear state.
    //
    // Return Values
    //   Returns TRUE if successful, or FALSE otherwise.
    //
    // See Also
    //   EnableItem, CheckRadioItem, InsertItem, SetItemInfo
    //
    function CheckItem( position : DWORD; byPosition : BOOL; checked : BOOL ) : BOOL; virtual; stdcall; abstract;

    //
    // CheckRadioItem
    //   Checks a specified menu item and makes it a radio item. At the same time, the method
    //   clears all other menu items in the associated group and clears the radio-item type
    //   flag for those items.
    //
    // Parameters
    //   'positionFirst'
    //      [in] Identifier or position of the first menu item in the group. 
    //      The meaning of this parameter depends on the value of 'byPosition'.
    //
    //   'positionLast'
    //      [in] Identifier or position of the last menu item in the group. 
    //      The meaning of this parameter depends on the value of 'byPosition'.
    //
    //   'positionCheck'
    //      [in] Identifier or position of the menu item to check. 
    //      The meaning of this parameter depends on the value of 'byPosition'.
    //
    //   'byPosition'
    //      [in] Value specifying the meaning of 'positionFirst', 'positionLast', and
    //      'positionCheck'. If this parameter is FALSE, the other parameters specify 
    //      menu item identifiers. Otherwise, the other parameters specify the menu
    //      item positions.
    //
    // Return Values
    //   Returns TRUE if successful, or FALSE otherwise.
    //
    // See Also
    //   EnableItem, CheckItem, InsertItem, SetItemInfo
    //
    function CheckRadioItem( positionFirst : DWORD; positionLast : DWORD; positionCheck : DWORD;
                             byPosition : BOOL ) : BOOL; virtual; stdcall; abstract;

    //
    // SetDefaultItem
    //   Sets the default menu item for the specified menu.
    //
    // Parameters
    //   'position'
    //      [in] Identifier or position of the new default menu item or 1 for no default item.
    //      The meaning of this parameter depends on the value of 'byPosition'.
    //
    //   'byPosition'
    //      [in] Value specifying the meaning of 'position'. If this parameter is FALSE, 'position'
    //      is a menu item identifier. Otherwise, it is a zero-based menu item position.
    //
    // Return Values
    //   Returns TRUE if successful, or FALSE otherwise.
    //
    // See Also
    //   EnableItem, CheckItem, CheckRadioItem, InsertItem, SetItemInfo
    //
    function SetDefaultItem( position : DWORD; byPosition : BOOL ) : BOOL; virtual; stdcall; abstract;


    //
    // EnableItem
    //   Enables or disables the specified menu item.
    //
    // Parameters
    //   'position'
    //      [in] Identifier or position of the menu item to be enabled or disabled.
    //      The meaning of this parameter depends on the value of 'byPosition'.
    //
    //   'byPosition'
    //      [in] Value specifying the meaning of 'position'. If this parameter is FALSE, 'position'
    //      is a menu item identifier. Otherwise, it is a zero-based menu item position.
    //
    //   'enabled'
    //      [in] Indicates whether the menu item will be enabled or disabled.
    //      If this parameter is TRUE, enables the menu item.
    //      If this parameter is FALSE, disables the menu item.
    //
    // Return Values
    //   Returns TRUE if successful, or FALSE otherwise.
    //
    // See Also
    //   CheckItem, InsertItem, SetItemInfo
    //
    function EnableItem( position : DWORD; byPosition : BOOL; enabled : BOOL ) : BOOL; virtual; stdcall; abstract;

    //
    // EnableItem
    //   Determines the number of items in the specified menu.
    //
    // Return Values
    //   The return value specifies the number of items in the menu.
    //
    function GetItemCount : Integer; virtual; stdcall; abstract;

    //
    // RemoveAllItems
    //   Deletes all items from the menu popup.
    //   If the removed menu item opens submenu, this method frees the memory used by the submenu.
    //
    // See Also
    //   RemoveItemsRange
    //
    procedure RemoveAllItems; virtual; stdcall; abstract;

    //
    // RemoveItemsRange
    //   Deletes items range from the menu popup.
    //
    // Parameters
    //   'firstIndex'
    //      [in] Specifies the first menu item to be deleted.
    //
    //   'lastIndex'
    //      [in] Specifies the last menu item to be deleted.
    //
    // Return Values
    //   Returns TRUE if successful, or FALSE otherwise.
    //
    // See Also
    //   RemoveAllItems
    //
    function RemoveItemsRange( firstIndex : Integer; lastIndex : Integer ) : BOOL; virtual; stdcall; abstract;

    //
    // BeginModifyMode
    //   Allows changes of the opened menu popup.
    //
    // Return Values
    //   Returns TRUE if successful, or FALSE otherwise.
    //
    // See Also
    //   EndModifyMode
    //
    function BeginModifyMode : BOOL; virtual; stdcall; abstract;

    //
    // EndModifyMode
    //   Ends modify mode.
    //
    // Return Values
    //   Returns TRUE if successful, or FALSE otherwise.
    //
    // See Also
    //   BeginModifyMode
    //
    function EndModifyMode : BOOL; virtual; stdcall; abstract;

    //
    // SetSkillLevel
    //   Sets user skill level for this menu popup.
    //
    // Parameters
    //   'skillLevel'
    //      [in] Specifies the user skill level.
    //      This parameter must be one or a combination of MENU_LEVEL_*.
    //
    procedure SetSkillLevel( skillLevel : DWORD ); virtual; stdcall; abstract;

    //
    // FindItemPosition
    //   Retrieves the menu item position in the menu popup.
    //
    // Parameters
    //   'id'
    //      [in] Specifies the identifier of the menu item whose position is to be retrieved.
    //
    // Return Values
    //   Zero-based position of the specified menu item.
    //   If menu item is not found, return value is -1.
    //
    function FindItemPosition( id : DWORD ) : Integer; virtual; stdcall; abstract;

    //
    // FillMenuHandle
    //   Inserts the menu items to the Windows menu popup.
    //
    // Parameters
    //   'hMenu'
    //      [in] Handle to the menu to be filled.
    //
    // Return Values
    //   Returns TRUE if successful, or FALSE otherwise.
    //
    function FillMenuHandle( hMenu : HMENU ) : BOOL; virtual; stdcall; abstract;

    //
    // GetStatesFromHWindowsMenu
    //   Applies Windows menu popup item states to the contained items.
    //
    // Parameters
    //   'hMenu'
    //      [in] Handle to the menu whose item states are to be retrieved.
    //
    // Return Values
    //   Returns TRUE if successful, or FALSE otherwise.
    //
    function GetStatesFromHWindowsMenu( hMenu : HMENU ) : BOOL; virtual; stdcall; abstract;

    //
    // SetImageList
    //   Sets the image list that the menu will use to display images in the items that
    //   are in their default state.
    //
    // Parameters
    //   'hImageList'
    //      [in] Handle to the image list that will be set.
    //      If this parameter is NULL, no images will be displayed in the items.
    //
    //   'subMenu'
    //      [in] Specifies whether to set SubMenus image list to.
    //      If this parameter is TRUE, image list will be set also in all submenu items,
    //      otherwise image list will be set only in this menu popup.
    //
    // See Also
    //   SetHotImageList
    //
    procedure SetImageList( hImageList : HIMAGELIST; subMenu : BOOL ); virtual; stdcall; abstract;

    //
    // SetHotImageList
    //   Sets the image list that the menu will use to display images in the items that
    //   are in their hot or checked state.
    //
    // Parameters
    //   'hImageList'
    //      [in] Handle to the image list that will be set.
    //      If this parameter is NULL, no images will be displayed in the items.
    //
    //   'subMenu'
    //      [in] Specifies whether to set SubMenus image list to.
    //      If this parameter is TRUE, image list will be set also in all submenu items,
    //      otherwise image list will be set only in this menu popup.
    //
    // See Also
    //   SetImageList
    //
    procedure SetHotImageList( hHotImageList : HIMAGELIST; subMenu : BOOL ); virtual; stdcall; abstract;

    //
    // Track
    //   Displays a shortcut menu at the specified location and tracks the selection of
    //   items on the shortcut menu.
    //
    // Parameters
    //   'trackFlags'
    //      [in] Specifies function options.
    //      This parameter can be a combination of MENU_TRACK_* flags.
    //
    //   'x'
    //      [in] Horizontal location of the shortcut menu, in screen coordinates.
    //
    //   'y'
    //      [in] Vertical location of the shortcut menu, in screen coordinates.
    //
    //   'hwnd'
    //      [in] Handle to the window that owns the shortcut menu. This window
    //      receives all messages from the menu. The window does not receive
    //      a WM_COMMAND message from the menu until the function returns.
    //
    //      If you specify MENU_TRACK_NONOTIFY in the 'trackFlags' parameter,
    //      the function does not send messages to the window identified by hwnd.
    //      However, you still have to pass a window handle in 'hwnd'. It can be
    //      any window handle from your application.
    //   'exclude'
    //      [in] Rectangle to exclude when positioning the window, in screen coordinates.
    //
    // Return Values
    //   If you specify MENU_TRACK_RETURNCMD in the 'trackFlags' parameter, the return
    //   value is the menu-item identifier of the item that the user selected. If the
    //   user cancels the menu without making a selection, or if an error occurs, then
    //   the return value is zero.
    //
    //   If you do not specify MENU_TRACK_RETURNCMD in the 'trackFlags' parameter, the
    //   return value is nonzero if the function succeeds and zero if it fails.
    //
    function Track( trackFlags : DWORD; x : Integer; y : Integer; hwnd : HWND;
                    exclude : PRect ) : DWORD; virtual; stdcall; abstract;

    //
    // GetItemRect
    //   Retrieves the bounding rectangle of a item in the menu.
    //
    // Parameters
    //   'index'
    //      [in] Zero-based index of the item for which to retrieve information.
    //
    //   'rect'
    //      [out] Address of a RECT structure that receives the screen coordinates
    //      of the bounding rectangle.
    //
    // Return Values
    //   Returns TRUE if successful, or FALSE otherwise.
    //
    function GetItemRect( index : Integer; rect : PRect ) : BOOL; virtual; stdcall; abstract;

    //
    // UpdateItemsState
    //   Updates state for all items with specified 'Enabler'.
    //   Call this method when enabler variables altered.
    //
    procedure UpdateItemsState; virtual; stdcall; abstract;

    //
    // SetMinWidth
    //   Sets the minimum width to be used for menu popup.
    //
    // Parameters
    //   'minWidth'
    //      [in] Specifies the minimum width of the menu popup.
    //
    procedure SetMinWidth( minWidth : Integer ); virtual; stdcall; abstract;

    //
    // SetPopupID
    //   Sets the ID for menu popup.
    //
    // Parameters
    //   'id'
    //      [in] Specifies the ID of the menu popup.
    //
    procedure SetPopupID( id : DWORD ); virtual; stdcall; abstract;

    //
    // GetPopupID
    //   Retrieves the ID for menu popup.
    //
    // Return Values
    //   Returns the ID for menu popup.
    //
    function GetPopupID : DWORD; virtual; stdcall; abstract;

    //
    // AssignHotKeys
    //   Automatically assigns hot keys to the menu items that
    //   has not hot key already assigned.
    //
    procedure AssignHotKeys; virtual; stdcall; abstract;
  end;

//
// ****************************************************************************
// CGUIMenuBarAbstract
//

  TGUIMenuBarAbstract = class
  // Vsechny metody je mozne volat pouze z threadu parent okna, ve kterem
  // byl objekt pripojen na windows control a ziskan ukazatel na toto rozhrani.

    //
    // CreateWnd
    //   Creates child toolbar window.
    //
    // Parameters
    //   'hParent'
    //      [in] Handle to the parent or owner window of the toolbar being created.
    //
    // Return Values
    //   Returns TRUE if successful, or FALSE otherwise.
    //
    function CreateWnd( hParent : HWND ) : BOOL; virtual; stdcall; abstract;

    //
    // GetHWND
    //   Retrieves Windows HWND value of the toolbar.
    //
    // Return Values
    //   The Windows HWND handle of the toolbar.
    //
    function GetHWND : HWND; virtual; stdcall; abstract;

    //
    // GetNeededWidth
    //   Retrieves the total width of all of the visible buttons and separators
    //   in the toolbar.
    //
    // Return Values
    //   Returns the needed width for the toolbar.
    //
    // See Also
    //   GetNeededHeight
    //
    function GetNeededWidth : Integer; virtual; stdcall; abstract;

    //
    // GetNeededHeight
    //   Retrieves the total height of all of the visible buttons and separators
    //   in the toolbar.
    //
    // Return Values
    //   Returns the needed height for the toolbar.
    //
    // See Also
    //   GetNeededWidth
    //
    function GetNeededHeight : Integer; virtual; stdcall; abstract;

    //
    // SetFont
    //   Updates the font that a menubar is to use when drawing text.
    //
    procedure SetFont; virtual; stdcall; abstract;

    //
    // GetItemRect
    //   Retrieves the bounding rectangle of a button in the toolbar.
    //
    // Parameters
    //   'index'
    //      [in] Zero-based index of the button for which to retrieve information.
    //
    //   'r'
    //      [out] Address of a RECT structure that receives the screen coordinates
    //      of the bounding rectangle.
    //
    // Return Values
    //   Returns TRUE if successful, or FALSE otherwise.
    //
    function GetItemRect( index : Integer; var r : TRect ) : BOOL; virtual; stdcall; abstract;

    // prepne menu do Menu mode (jako by user stisknul a pustil Alt)
    procedure EnterMenu; virtual; stdcall; abstract;
    // vraci TRUE, pokud je menu v Menu mode
    function IsInMenuLoop : BOOL; virtual; stdcall; abstract;
    // prepina menu do Help mode (Shift + F1)
    procedure SetHelpMode( helpMode : BOOL ); virtual; stdcall; abstract;

    //
    // IsMenuBarMessage
    //   The IsMenuBarMessage method determines whether a message is intended for
    //   the menubar or menu and, if it is, processes the message.
    //
    // Parameters
    //   'lpMsg'
    //      [in] Pointer to an MSG structure that contains the message to be checked.
    //
    // Return Values
    //   If the message has been processed, the return value is nonzero.
    //   If the message has not been processed, the return value is zero.
    //
    function IsMenuBarMessage( lpMsg : PMsg ) : BOOL; virtual; stdcall; abstract;
  end;

//
// ****************************************************************************
// CGUIToolBarAbstract
//

  TLBI_ITEM_INFO = packed record
    Mask       : DWORD;
    Style      : DWORD;
    State      : DWORD;
    ID         : DWORD;
    Text       : PChar;
    TextLen    : Integer;
    Width      : Integer;
    ImageIndex : Integer;
    HIcon      : HICON;
    CustomData : DWORD;
    Enabler    : PDWORD;
    Index      : DWORD;
    Name       : PChar;
    NameLen    : Integer;
  end;
  PLBI_ITEM_INFO = ^TLBI_ITEM_INFO;
(*
Mask
  TLBI_MASK_*

Style
  TLBI_STYLE_*

State
  TLBI_STATE_*

ID
  Command identifier associated with the button.
  This identifier is used in a WM_COMMAND message when the button is chosen.

Text
  Text string displayed in the toolbar item.

TextLen
  Length of the toolbar item text, when information is received.

Width
  Width of the toolbar item text.

ImageIndex
  Zero-based index of the button image in the image list.

HIcon
  Handle to the icon to display instead of image list image.
  Icon will not be destroyet.

CustomData
  Application-defined value associated with the toolbar item.

Enabler
  Pointer to the item enabler. Used in the UpdateItemsState.
  0 -> item is TLBI_STATE_GRAYED; else item is enabled

Index
  For enumeration items in customize dialog.

Name
  Name in customize dialog.

NameLen
  Name len in customize dialog.
*)

  // The padding values are used to create a blank area
  TOOLBAR_PADDING = packed record
    ToolBarVertical : Word;                                                     // blank area above and below the button
    ButtonIconText  : Word;                                                     // blank area between icon and text
    IconLeft        : Word;                                                     // blank area before icon
    IconRight       : Word;                                                     // blank area behind icon
    TextLeft        : Word;                                                     // blank area before text
    TextRight       : Word;                                                     // blank area behind text
  end;
  PTOOLBAR_PADDING = ^TOOLBAR_PADDING;

  TOOLBAR_TOOLTIP = packed record
    HToolBar   : HWND;                                                          // okno, ktere se dotazuje na tooltip
    ID         : DWORD;                                                         // ID buttonu, pro ktere je pozadovan tooltip
    Index      : DWORD;                                                         // index buttonu, pro ktere je pozadovan tooltip
    CustomData : DWORD;                                                         // custom data buttonu, pokud jsou definovany
    Buffer     : PChar;                                                         // tento buffer je treba naplnit, maximlani pocet znaku je TOOLTIP_TEXT_MAX
                                                                                // implicitne message je na nulty znak vlozen terminator
  end;
  PTOOLBAR_TOOLTIP = ^TOOLBAR_TOOLTIP;

  TGUIToolBarAbstract = class
  // Vsechny metody je mozne volat pouze z threadu parent okna, ve kterem
  // byl objekt pripojen na windows control a ziskan ukazatel na toto rozhrani.

    //
    // CreateWnd
    //   Creates child toolbar window.
    //
    // Parameters
    //   'hParent'
    //      [in] Handle to the parent or owner window of the toolbar being created.
    //
    // Return Values
    //   Returns TRUE if successful, or FALSE otherwise.
    //
    function CreateWnd( hParent : HWND ) : BOOL; virtual; stdcall; abstract;

    //
    // GetHWND
    //   Retrieves Windows HWND value of the toolbar.
    //
    // Return Values
    //   The Windows HWND handle of the toolbar.
    //
    function GetHWND : HWND; virtual; stdcall; abstract;

    //
    // GetNeededWidth
    //   Retrieves the total width of all of the visible buttons and separators
    //   in the toolbar.
    //
    // Return Values
    //   Returns the needed width for the toolbar.
    //
    // See Also
    //   GetNeededHeight
    //
    function GetNeededWidth : Integer; virtual; stdcall; abstract;

    //
    // GetNeededHeight
    //   Retrieves the total height of all of the visible buttons and separators
    //   in the toolbar.
    //
    // Return Values
    //   Returns the needed height for the toolbar.
    //
    // See Also
    //   GetNeededWidth
    //
    function GetNeededHeight : Integer; virtual; stdcall; abstract;

    //
    // SetFont
    //   Updates the font that a menubar is to use when drawing text.
    //
    procedure SetFont; virtual; stdcall; abstract;

    //
    // GetItemRect
    //   Retrieves the bounding rectangle of a button in the toolbar.
    //
    // Parameters
    //   'index'
    //      [in] Zero-based index of the button for which to retrieve information.
    //
    //   'r'
    //      [out] Address of a RECT structure that receives the screen coordinates
    //      of the bounding rectangle.
    //
    // Return Values
    //   Returns TRUE if successful, or FALSE otherwise.
    //
    function GetItemRect( index : Integer; var r : TRect ) : BOOL; virtual; stdcall; abstract;

    //
    // InsertItem
    //   Inserts a new button at the specified position in a toolbar.
    //
    // Parameters
    //   'position'
    //      [in] Identifier or position of the button before which to insert the new button.
    //      The meaning of this parameter depends on the value of 'byPosition'.
    //
    //   'byPosition'
    //      [in] Value specifying the meaning of 'position'. If this parameter is FALSE, 'position'
    //      is a button identifier. Otherwise, it is a zero-based button position.
    //
    //   'tii'
    //      [in] Pointer to a TLBI_ITEM_INFO structure that contains information about the
    //      new button.
    //
    // Return Values
    //   Returns TRUE if successful, or FALSE otherwise.
    //
    // See Also
    //   SetItemInfo, GetItemInfo
    //
    function InsertItem( position : DWORD; byPosition : BOOL; tii : PLBI_ITEM_INFO ) : BOOL; virtual; stdcall; abstract;

    //
    // SetItemInfo
    //   Changes information about a button.
    //
    // Parameters
    //   'position'
    //      [in] Identifier or position of the button to change.
    //      The meaning of this parameter depends on the value of 'byPosition'.
    //
    //   'byPosition'
    //      [in] Value specifying the meaning of 'position'. If this parameter is FALSE, 'position'
    //      is a button identifier. Otherwise, it is a zero-based button position.
    //
    //   'mii'
    //      [in] Pointer to a TLBI_ITEM_INFO structure that contains information about the button
    //      and specifies which button attributes to change.
    //
    // Return Values
    //   Returns TRUE if successful, or FALSE otherwise.
    //
    // See Also
    //   InsertItem, GetItemInfo
    //
    function SetItemInfo( position : DWORD; byPosition : BOOL; tii : PLBI_ITEM_INFO ) : BOOL; virtual; stdcall; abstract;

    //
    // GetItemInfo
    //   Retrieves information about a button.
    //
    // Parameters
    //   'position'
    //      [in] Identifier or position of the button to get information about.
    //      The meaning of this parameter depends on the value of 'byPosition'.
    //
    //   'byPosition'
    //      [in] Value specifying the meaning of 'position'. If this parameter is FALSE, 'position'
    //      is a button identifier. Otherwise, it is a zero-based button position.
    //
    //   'mii'
    //      [in/out] Pointer to a TLBI_ITEM_INFO structure that contains information to retrieve
    //      and receives information about the button.
    //
    // Return Values
    //   Returns TRUE if successful, or FALSE otherwise.
    //
    // See Also
    //   InsertItem, SetItemInfo
    //
    function GetItemInfo( position : DWORD; byPosition : BOOL; tii : PLBI_ITEM_INFO ) : BOOL; virtual; stdcall; abstract;

    // CheckItem
    //   Sets the state of the specified button's attribute to either checked or normal.
    //
    // Parameters
    //   'position'
    //      [in] Identifier or position of the button to change.
    //      The meaning of this parameter depends on the value of 'byPosition'.
    //
    //   'byPosition'
    //      [in] Value specifying the meaning of 'position'. If this parameter is FALSE, 'position'
    //      is a button identifier. Otherwise, it is a zero-based button position.
    //
    //   'checked'
    //      [in] Indicates whether the button will be checked or cleared.
    //      If this parameter is TRUE, sets the button to the checked state.
    //      If this parameter is FALSE, sets the button to the normal state.
    //
    // Return Values
    //   Returns TRUE if successful, or FALSE otherwise.
    //
    // See Also
    //   EnableItem, InsertItem, SetItemInfo
    //
    function CheckItem( position : DWORD; byPosition : BOOL; checked : BOOL ) : BOOL; virtual; stdcall; abstract;

    //
    // EnableItem
    //   Enables or disables the specified button.
    //
    // Parameters
    //   'position'
    //      [in] Identifier or position of the button to be enabled or disabled.
    //      The meaning of this parameter depends on the value of 'byPosition'.
    //
    //   'byPosition'
    //      [in] Value specifying the meaning of 'position'. If this parameter is FALSE, 'position'
    //      is a button identifier. Otherwise, it is a zero-based button position.
    //
    //   'enabled'
    //      [in] Indicates whether the button will be enabled or disabled.
    //      If this parameter is TRUE, enables the button.
    //      If this parameter is FALSE, disables the button.
    //
    // Return Values
    //   Returns TRUE if successful, or FALSE otherwise.
    //
    // See Also
    //   CheckItem, InsertItem, SetItemInfo
    //
    function EnableItem( position : DWORD; byPosition : BOOL; enabled : BOOL ) : BOOL; virtual; stdcall; abstract;

    //
    // ReplaceImage
    //   Replaces an existing bitmap with a new bitmap.
    //
    // Parameters
    //   'position'
    //      [in] Identifier or position of the button to change.
    //      The meaning of this parameter depends on the value of 'byPosition'.
    //
    //   'byPosition'
    //      [in] Value specifying the meaning of 'position'. If this parameter is FALSE, 'position'
    //      is a button identifier. Otherwise, it is a zero-based button position.
    //
    //   'hIcon'
    //      [in] Handle to the icon that contains the bitmap and mask for the new image.
    //
    //   'normal'
    //      [in] Specifies whether to replace normal image list icon.
    //
    //   'hot'
    //      [in] Specifies whether to replace hot image list icon.
    //
    // Return Values
    //   Returns TRUE if successful, or FALSE otherwise.
    //
    function ReplaceImage( position : DWORD; byPosition : BOOL; hIcon : HICON;
                           normal : BOOL; hot : BOOL ) : BOOL; virtual; stdcall; abstract;

    //
    // FindItemPosition
    //   Retrieves the button position in the toolbar.
    //
    // Parameters
    //   'id'
    //      [in] Specifies the identifier of the button whose position is to be retrieved.
    //
    // Return Values
    //   Zero-based position of the specified button.
    //   If button is not found, return value is -1.
    //
    function FindItemPosition( id : DWORD ) : Integer; virtual; stdcall; abstract;

    //
    // SetImageList
    //   Sets the image list that the toolbar will use to display images in the button
    //   that are in their default state.
    //
    // Parameters
    //   'hImageList'
    //      [in] Handle to the image list that will be set.
    //
    // See Also
    //   GetImageList, GetHotImageList, SetHotImageList
    //
    procedure SetImageList( hImageList : HIMAGELIST ); virtual; stdcall; abstract;

    //
    // GetImageList
    //   Retrieves the image list that a toolbar uses to display buttons
    //   in their default state.
    //
    // Return Values
    //   Returns the handle to the image list, or NULL if no image list is set.
    //
    // See Also
    //   SetImageList, GetHotImageList, SetHotImageList
    //
    function GetImageList : HIMAGELIST; virtual; stdcall; abstract;

    //
    // SetHotImageList
    //   Sets the image list that the toolbar will use to display images in the button
    //   that are in their hot state.
    //
    // Parameters
    //   'hImageList'
    //      [in] Handle to the image list that will be set.
    //
    // See Also
    //   SetImageList, GetImageList, SetHotImageList
    //
    procedure SetHotImageList( hImageList : HIMAGELIST ); virtual; stdcall; abstract;

    //
    // GetHotImageList
    //   Retrieves the image list that a toolbar uses to display hot buttons.
    //
    // Return Values
    //   Returns the handle to the image list that the toolbar uses to display hot
    //   buttons, or NULL if no hot image list is set.
    //
    // See Also
    //   SetImageList, GetImageList, SetHotImageList
    //
    function GetHotImageList : HIMAGELIST; virtual; stdcall; abstract;


    //
    // SetStyle
    //   Sets the styles for the toolbar.
    //
    // Parameters
    //   'style'
    //      [in] Value specifying the styles to be set for the toolbar.
    //      This parameter can be a combination of TLB_STYLE_* styles.
    //
    // See Also
    //   GetStyle
    //
    procedure SetStyle( style : DWORD ); virtual; stdcall; abstract;

    //
    // GetStyle
    //   Retrieves the styles currently in use for the toolbar.
    //
    // Return Values
    //   Returns a DWORD value that is a combination of TLB_STYLE_* styles.
    //
    // See Also
    //   SetStyle
    //
    function GetStyle : DWORD; virtual; stdcall; abstract;

    //
    // RemoveItem
    //   Deletes a button from the toolbar.
    //
    // Parameters
    //   'position'
    //      [in] Identifier or position of the button to delete.
    //      The meaning of this parameter depends on the value of 'byPosition'.
    //
    //   'byPosition'
    //      [in] Value specifying the meaning of 'position'. If this parameter is FALSE, 'position'
    //      is a button identifier. Otherwise, it is a zero-based button position.
    //
    // Return Values
    //   Returns TRUE if successful, or FALSE otherwise.
    //
    // See Also
    //   RemoveAllItems
    //
    function RemoveItem( position : DWORD; byPosition : BOOL ) : BOOL; virtual; stdcall; abstract;

    //
    // RemoveAllItems
    //   Deletes all buttons from the toolbar.
    //
    // See Also
    //   RemoveItem
    //
    procedure RemoveAllItems; virtual; stdcall; abstract;

    //
    // GetItemCount
    //   Retrieves a count of the buttons currently in the toolbar.
    //
    // Return Values
    //   Returns the count of the buttons.
    //
    function GetItemCount : Integer; virtual; stdcall; abstract;

    //
    // Customize
    //   Displays the Customize Toolbar dialog box.
    //
    procedure Customize; virtual; stdcall; abstract;

    //
    // SetPadding
    //   Sets the padding for a toolbar control.
    //
    // Parameters
    //   'padding'
    //      [in] Address of a TOOLBAR_PADDING structure that contains
    //      the new padding information.
    //
    // See Also
    //   GetPadding
    //

    procedure SetPadding( padding : PTOOLBAR_PADDING ); virtual; stdcall; abstract;

    //
    // GetPadding
    //   Retrieves the padding for the toolbar.
    //
    // Parameters
    //   'padding'
    //      [out] Address of a TOOLBAR_PADDING structure that will receive
    //      the padding information.
    //
    // See Also
    //   SetPadding
    //
    procedure GetPadding( padding : PTOOLBAR_PADDING ); virtual; stdcall; abstract;

    //
    // UpdateItemsState
    //   Updates state for all items with specified 'Enabler'.
    //   Call this method when enabler variables altered.
    //
    procedure UpdateItemsState; virtual; stdcall; abstract;

    //
    // HitTest
    //   Determines where a point lies in the toolbar.
    //
    // Parameters
    //   'xPos'
    //      [in] The x-coordinate of the hit test.
    //
    //   'yPos'
    //      [in] The y-coordinate of the hit test.
    //
    // Return Values
    //   Returns an integer value. If the return value is zero or a positive value,
    //   it is the zero-based index of the nonseparator item in which the point lies.
    //   If the return value is negative, the point does not lie within a button.
    //
    // Remarks
    //   The coordinates are relative to the toolbar's client area.
    //
    function HitTest( xPos : Integer; yPos : Integer ) : Integer; virtual; stdcall; abstract;

    //
    // InsertMarkHitTest
    //   Retrieves the insertion mark information for a point in the toolbar.
    //
    // Parameters
    //   'xPos'
    //      [in] The x-coordinate of the hit test.
    //
    //   'yPos'
    //      [in] The y-coordinate of the hit test.
    //
    //   'index'
    //      [out] Zero-based index of the button with insertion mark.
    //      If this member is -1, there is no insertion mark.
    //
    //   'after'
    //      [out] Defines where the insertion mark is in relation to 'index'.
    //      If the value is FALSE, the insertion mark is to the left of the specified button.
    //      If the value is TRUE, the insertion mark is to the right of the specified button.
    //
    // Return Values
    //   Returns TRUE if the point is an insertion mark, or FALSE otherwise.
    //
    // Remarks
    //   The coordinates are relative to the toolbar's client area.
    //
    // See Also
    //   SetInsertMark
    //
    function InsertMarkHitTest( xPos : Integer; yPos : Integer; var index : Integer;
                                var after : BOOL ) : BOOL; virtual; stdcall; abstract;

    //
    // SetInsertMark
    //   Sets the current insertion mark for the toolbar.
    //
    // Parameters
    //   'index'
    //      [out] Zero-based index of the button with insertion mark.
    //      If this member is -1, there is no insertion mark.
    //
    //   'after'
    //      [out] Defines where the insertion mark is in relation to 'index'.
    //      If the value is FALSE, the insertion mark is to the left of the specified button.
    //      If the value is TRUE, the insertion mark is to the right of the specified button.
    //
    // See Also
    //   InsertMarkHitTest
    //
    procedure SetInsertMark( index : Integer; after : BOOL ); virtual; stdcall; abstract;

    //
    // SetHotItem
    //   Sets the hot item in the toolbar.
    //
    // Parameters
    //   'index'
    //      [out] Zero-based index of the item that will be made hot.
    //      If this value is -1, none of the items will be hot.
    //
    // Return Values
    //   Returns the index of the previous hot item, or -1 if there was no hot item.
    //
    function SetHotItem( index : Integer ) : Integer; virtual; stdcall; abstract;

    //
    // SetHotItem
    //   Updates the toolbar graphic handles.
    //
    procedure OnColorsChanged; virtual; stdcall; abstract;
  end;

//
// ****************************************************************************
// CSalamanderGUIAbstract
//

  TSalamanderGUIAbstract = class
    ///////////////////////////////////////////////////////////////////////////
    //
    // ProgressBar
    //
    // Slouzi k zobrazeni stavu operace v procentech uz vykonane prace.
    // Ma vyznam u operaci, ktere mohou zabrat vetsi mnostvi casu. Tam je
    // progress lepsi nez pouhy kurzor WAIT.
    //
    // pripoji Salamanderovsky progress bar na Windows control (tento control urcuje pozici
    // progress bary); 'hParent' je handle parent okna (dialog nebo okno); ctrlID je ID
    // Windows controlu; pri uspesnem pripojeni vraci rozhrani progress bary,
    // jinak vraci NULL; rozhrani je platne az do okamziku destrukce (doruceni WM_DESTROY)
    // Windows controlu; po pripojeni je progress bar nastaven na 0%;
    // testovano na Windows controlu "STATIC" s flagy SS_WHITEFRAME | WS_CHILD | WS_VISIBLE | WS_BORDER
    function AttachProgressBar( hParent : HWND; ctrlID : Integer ) : TGUIProgressBarAbstract; virtual; stdcall; abstract;

    ///////////////////////////////////////////////////////////////////////////
    //
    // StaticText
    //
    // Slouzi pro zobrazeni nestandardnich textu v dialogu (tucny, podtrzeny),
    // textu ktere se rychle meni a blikaly by nebo textu s nepredvidatelnou delkou,
    // ktere je treba inteligentne zkratit.
    //
    // pripoji Salamanderovsky StaticText na Windows control (tento control urcuje pozici
    // StaticTextu); 'hParent' je handle parent okna (dialog nebo okno); ctrlID je ID;
    // 'flags' je z rodiny STF_*, muze byt 0 nebo libovolna kombinace hodnot;
    // Windows controlu; pri uspesnem pripojeni vraci rozhrani StaticTextu,
    // jinak vraci NULL; rozhrani je platne az do okamziku destrukce (doruceni WM_DESTROY)
    // Windows controlu; po pripojeni je vytazen text a zarovnani z Windows controlu.
    // testovano na Windows controlu "STATIC"
    function AttachStaticText( hParent : HWND; ctrlID : Integer; flags : DWORD ) : TGUIStaticTextAbstract; virtual; stdcall; abstract;

    ///////////////////////////////////////////////////////////////////////////
    //
    // HyperLink
    //
    // Slouzi pro zobrazeni hyperlinku. Po kliknuti je mozne otevrit URL adresu
    // nebo spustit soubor (SetActionOpen), nebo nechat postnout command zpet
    // do dialogu (SetActionPostCommand).
    // Control je pristupny pres klavesu TAB (muze mit focus), ale je treba mu
    // nastavit WS_TABSTOP. Akci pak vyvolame klavesou Space. Pravym tlacitkem
    // nebo pomoci Shift+F10 lze vyvolat menu s moznosti nakopirovat text controlu
    // na clipboard.
    //
    // pripoji Salamanderovsky HyperLink na Windows control (tento control urcuje pozici
    // HyperLinku); 'hParent' je handle parent okna (dialog nebo okno); ctrlID je ID Windows controlu;
    // 'flags' je z rodiny STF_*, muze byt 0 nebo libovolna kombinace hodnot;
    // doporucena kombinace pro HyperLink je STF_UNDERLINE | STF_HYPERLINK_COLOR
    // pri uspesnem pripojeni vraci rozhrani HyperLinku, jinak vraci NULL; rozhrani je
    // platne az do okamziku destrukce (doruceni WM_DESTROY) Windows controlu; po pripojeni
    // je vytazen text a zarovnani z Windows controlu.
    // testovano na Windows controlu "STATIC"
    function AttachHyperLink( hParent : HWND; ctrlID : Integer; flags : DWORD ) : TGUIHyperLinkAbstract; virtual; stdcall; abstract;

    ///////////////////////////////////////////////////////////////////////////
    //
    // Button
    //
    // Slouzi pro vytvoreni tlacitka s textem nebo ikonou. Tlacitko muze obsahovat sipku
    // vpravo nebo drop-down sipku. Viz flagy BTF_xxx.
    //
    // pripoji Salamanderovsky TextArrowButton na Windows control (tento control urcuje pozici,
    // text nebo ikonu a generovany command); 'hParent' je handle parent okna (dialog nebo okno);
    // ctrlID je ID Windows controlu;
    // pri uspesnem pripojeni vraci rozhrani CGUIButtonAbstract, jinak vraci NULL; rozhrani je
    // platne az do okamziku destrukce (doruceni WM_DESTROY) Windows controlu;
    // Testovano na Windows controlu "BUTTON".
    function AttachButton( hParent : HWND; ctrlID : Integer; flags : DWORD ) : TGUIButtonAbstract; virtual; stdcall; abstract;

    ///////////////////////////////////////////////////////////////////////////
    //
    // ColorArrowButton
    //
    // Slouzi pro vytvoreni tlacitka s barevnym obdelnickem, ktery naselduje sipka smerujici vpravo.
    // (pokud je showArrow==TRUE)
    // V obdelnicku je zobrazen text, ktery muze mit prirazenou jinou barvu nez barva pozadi obdelnicku.
    // Pouziva se v konfiguracich barev, kde dokaze zobrazit jednu nebo dve barvy.
    // Po stisku je vybaleno popup menu s moznosti zvolit, kterou barvu konfigurujeme..
    //
    // pripoji Salamanderovsky ColorArrowButton na Windows control (tento control urcuje pozici,
    // text a command ColorArrowButtonu); 'hParent' je handle parent okna (dialog nebo okno);
    // ctrlID je ID Windows controlu;
    // pri uspesnem pripojeni vraci rozhrani ColorArrowButtonu, jinak vraci NULL; rozhrani je
    // platne az do okamziku destrukce (doruceni WM_DESTROY) Windows controlu;
    // Testovano na Windows controlu "BUTTON".
    function AttachColorArrowButton( hParent : HWND; ctrlID : Integer; showArrow : BOOL ) : TGUIColorArrowButtonAbstract; virtual; stdcall; abstract;

    ///////////////////////////////////////////////////////////////////////////
    //
    // ChangeToArrowButton
    //
    // Slouzi pro vytvoreni tlacitka s sipkou smerujici vpravo umistene uprostred
    // tlacitka. Vklada se za vstupni pole a po stisku je vedle tlacitka vybaleno
    // popup menu obsahujici polozky vlozitelne do vstupniho pole (forma napovedy).
    //
    // Meni styl tlacitka, aby mohlo drzet ikonku s sipkou a potom tuto ikonku
    // prirazuje. Nepripojuje zadny Salamanderovsky objekt ke controlu, protoze
    // vse zvladne operacni system. Vraci TRUE v pripade uspechul, jinak FALSE.
    // Text tlacitka je ignorovan.
    // Testovano na Windows controlu "BUTTON".
    function ChangeToArrowButton( hParent : HWND; ctrlID : Integer ) : BOOL; virtual; stdcall; abstract;


    ///////////////////////////////////////////////////////////////////////////
    //
    // MenuPopup
    //
    // Slouzi pro vytvoreni prazdneho popup menu. Vraci ukazatel na iface nebo
    // NULL pri chybe.
    function CreateMenuPopup : TGUIMenuPopupAbstract; virtual; stdcall; abstract;
    // Slouzi pro uvolneni alokovaneho menu.
    function DestroyMenuPopup( popup : TGUIMenuPopupAbstract ) : BOOL; virtual; stdcall; abstract;

    ///////////////////////////////////////////////////////////////////////////
    //
    // MenuBar
    //
    // Slouzi pro vytvoreni menu bar; polozky 'menu' budou zobrazeny v menu bar,
    // jejich childy budou submenu; 'hNotifyWindow' identifikuje okno, kteremu
    // budou zasilany commandy a notifikace. Vraci ukazatel na iface nebo NULL
    // pri chybe.
    function CreateMenuBar( menu : TGUIMenuPopupAbstract; hNotifyWindow : HWND ) : TGUIMenuBarAbstract; virtual; stdcall; abstract;
    // Slouzi pro uvolneni alokovane menu bar. Zaroven destruuje okno.
    function DestroyMenuBar( menuBar : TGUIMenuBarAbstract ) : BOOL; virtual; stdcall; abstract;

    ///////////////////////////////////////////////////////////////////////////
    //
    // ToolBar support
    //
    // Slouzi pro vytvoreni neaktivni (sede) verze bitmap pro menu nebo toolbar.
    // Ze zdrojove bitmapy 'hSource' vytvori bitmapu ve stupnich sedi 'hGrayscale'
    // a cernobilou masku 'hMask'. Barva 'transparent' je povazovana za pruhlednou.
    // Pri uspechu vraci TRUE  a 'hGrayscale' a 'hMask'; pri chybe vraci FALSE.
    function CreateGrayscaleAndMaskBitmaps( hSource : HBITMAP; transparent : TColorRef;
                                            var hGrayscale : HBITMAP; var hMask : HBITMAP ) : BOOL; virtual; stdcall; abstract;

    ///////////////////////////////////////////////////////////////////////////
    //
    // ToolBar
    //
    // Slouzi pro vytvoreni tool bar; 'hNotifyWindow' identifikuje okno, kteremu
    // budou zasilany commandy a notifikace. Vraci ukazatel na iface nebo NULL
    // pri chybe.
    function CreateToolBar( hNotifyWindow : HWND ) : TGUIToolBarAbstract; virtual; stdcall; abstract;
    // Slouzi pro uvolneni alokovane tool bar. Zaroven destruuje okno.
    function DestroyToolBar( toolBar : TGUIToolBarAbstract ) : BOOL; virtual; stdcall; abstract;

    ///////////////////////////////////////////////////////////////////////////
    //
    // ToolTip
    //
    // Tato metoda spusti casovac a pokud do jeho vyprseni neni zavolana znovu
    // pozada okno 'hNotifyWindow' o text pomoci zpravy WM_USER_TTGETTEXT,
    // ktery pak zobrazi pod kurzor na jeho aktualnich souradnicich.
    // Promenna 'id' slouzi k rozliseni oblasti pri komunikaci s oknem 'hNotifyWindow'.
    // Pokud bude tato metoda zavolana vicekrat se stejnym parametrem 'id', budou
    // se tyto dalsi volani ignorovat.
    // Hodnota 0 parametru 'hNotifyWindow' je vyhrazena pro zhasnuti okna a preruseni
    // beziciho casovace.
    procedure SetCurrentToolTip( hNotifyWindow : HWND; id : DWORD ); virtual; stdcall; abstract;
    // potlaci zobrazeni tooltipu na aktualnich souradnicich mysi
    // uzitecne volat pri aktivaci okna, ve kterem se tooltipy pouzivaji
    // nebude tak dochazet k nechtenemu zobrazeni tooltipu
    procedure SuppressToolTipOnCurrentMousePos; virtual; stdcall; abstract;

    ///////////////////////////////////////////////////////////////////////////
    //
    // XP Visual Styles
    //
    // Pokud je zavolana pod operacnim system podporujicim vizualni styly,
    // vola SetWindowTheme(hWindow, L" ", L" ") pro zakazani vizualnich stylu
    // pro okno 'hWindow'
    // vraci TRUE, pokud operacni system podporuje vizualni styly, jinak vraci FALSE
    function DisableWindowVisualStyles( hWindow : HWND ) : BOOL; virtual; stdcall; abstract;
  end;

implementation

end.
