(*
  Object Pascal translation of the Altap Salamander SDK library.
  Original source: spl_vers.h

  Portions created by ALTAP are Copyright (c) ALTAP, spol. s r.o.
  All rights reserved.

  Portions created by LostGenius Posse are Copyright (c) 2007, LostGenius Posse (Timo 'jomanto' Boll)
  All rights reserved.

  Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

      * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
      * Redistributions in binary form may reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
      * Neither the name of the LostGenius Posse nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*)
(*
  History:
  
  2007-05-29: initial version
*)
unit spl_vers;

interface

// VERSINFO_BETAVERSION slouzi k snadnemu vydani beta verzi; do ted bylo nutne
// pri releasu nove bety obehnout vsechny pluginy a zvysit jim verze nyni staci
// zvysit tuto konstantu; v pripade releasu finalni verze (2.5, 3, ...) nastavime
// tuto verzi na nulu.
//
// VERSINFO_MAJOR a VERSINFO_MINOR(A/B) zvysujeme pouze v pripade "zajimavych"
// zmen provedenych v pluginu nebo pred uvolnenim finalni verze (2.5, 3, ...)
// Obe konstanty jsou definovany v kazdem pluginu v souboru versinfo.rh
//
// VERSINFO_BETAVERSION a VERSINFO_BETAVERSION_TXT zvysujeme s kazdou beta verzi
// v pripade release verze bude VERSINFO_BETAVERSION==0 a VERSINFO_BETAVERSION_TXT=""
// Pokud vydavame specialni opravne beta verze typu 2.5 beta 9a, bude
// VERSINFO_BETAVERSION==901 a VERSINFO_BETAVERSION_TXT==" beta 9a"

// POZOR: je potreba zmenit jeste v SALAMAND\VERSINFO.RH

const
  VERSINFO_BETAVERSION     = 0;    // pro release verze
  VERSINFO_BETAVERSION_TXT = '';   // pro release verze
//  VERSINFO_BETAVERSION     =  15;
//  VERSINFO_BETAVERSION_TXT = ' RC3';

// podpora pro kontrolu aktualnosti verze Salamandera, kterou plugin provadi
// behem entry-pointu (SalamanderPluginEntry) viz metoda
// CSalamanderPluginEntryAbstract::GetVersion() (v spl_base.h) + verze, pro
// kterou byl plugin postaven (viz export pluginu SalamanderPluginGetReqVer)

// (aktualni verzi odpovidaji konstanty LAST_VERSION_OF_SALAMANDER a REQUIRE_LAST_VERSION_OF_SALAMANDER)
//   1  - 1.6 beta 4 + 5
//   2  - 1.6 beta 6
//   3  - 1.6 beta 7
//   4  - 2.0
//   5  - 2.5 beta 1
//   6  - 2.5 beta 2
//   7  - 2.5 beta 3
//   8  - 2.5 beta 4
//   9  - 2.5 beta 5
//   10 - 2.5 beta 6
//   11 - 2.5 beta 7
//   12 - 2.5 beta 8
//   13 - 2.5 beta 9
//   14 - 2.5 beta 10
//   15 - 2.5 beta 10a
//   16 - 2.5 beta 11
//   17 - 2.5 beta 12 (jen interni, pustili jsme misto ni RC1)
//   18 - 2.5 RC1
//   19 - 2.5 RC2
//   20 - 2.5 RC3
//   21 - 2.5

  LAST_VERSION_OF_SALAMANDER         = 21;
  REQUIRE_LAST_VERSION_OF_SALAMANDER = 'This plugin requires Altap Salamander 2.5 or later.';

implementation

end.
